// Import the shox96 decompression library 
// And the compressed header file containing the Tao Te Ching
#include "shox96_progmem_0_2.h"
#include "tao.h"

// Pin to flash
int pin = 12;

// Set the morse code tempo
// 240 ~5wpm
// 120 ~10wpm
// 80 ~15wpm
int t = 240;

// Setup the arduino
void setup() {

  // Begin a serial connection at 9600 baud
  Serial.begin(9600);

  // Set the output pin to flash
  pinMode(pin, OUTPUT);

}

// Perform the dits
void d() {
 digitalWrite(pin, HIGH);
 delay(1 * t);
 digitalWrite(pin, LOW);
 delay(1 * t);
}

// Perform the das
void da() {
 digitalWrite(pin, HIGH);
 delay(3 * t);
 digitalWrite(pin, LOW);
 delay(1 * t);
}

// Define the pattern of dits and das for each letter
void morse(byte l) {

  if (l == 'A' or l == 'a') {d(); da();}
  else if (l == 'B' or l == 'b') {da(); d(); d(); d();}
  else if (l == 'C' or l == 'c') {da(); d(); da(); d();}
  else if (l == 'D' or l == 'd') {da(); d(); d();}
  else if (l == 'E' or l == 'e') {d();}
  else if (l == 'F' or l == 'f') {d(); d(); da(); d();}
  else if (l == 'G' or l == 'g') {da(); da(); d();}
  else if (l == 'H' or l == 'h') {d(); d(); d(); d();}
  else if (l == 'I' or l == 'i') {d(); d();}
  else if (l == 'J' or l == 'j') {d(); da(); da(); da();}
  else if (l == 'K' or l == 'k') {da(); d(); da();}
  else if (l == 'L' or l == 'l') {d(); da(); d(); d();}
  else if (l == 'M' or l == 'm') {da(); da();}
  else if (l == 'N' or l == 'n') {da(); d();}
  else if (l == 'O' or l == 'o') {da(); da(); da();}
  else if (l == 'P' or l == 'p') {d(); da(); da(); d();}
  else if (l == 'Q' or l == 'q') {da(); da(); d(); da();}
  else if (l == 'R' or l == 'r') {d(); da(); d();}
  else if (l == 'S' or l == 's') {d(); d(); d();}
  else if (l == 'T' or l == 't') {da();}
  else if (l == 'U' or l == 'u') {d(); d(); da();}
  else if (l == 'V' or l == 'v') {d(); d(); d(); da();}
  else if (l == 'W' or l == 'w') {d(); da(); da();}
  else if (l == 'X' or l == 'x') {da(); d(); d(); da();}
  else if (l == 'Y' or l == 'y') {da(); d(); da(); da();}
  else if (l == 'Z' or l == 'z') {da(); da(); d(); d();}
  else if (l == '1') {d(); da(); da(); da(); da();}
  else if (l == '2') {d(); d(); da(); da(); da();}
  else if (l == '3') {d(); d(); d(); da(); da();}
  else if (l == '4') {d(); d(); d(); d(); da();}
  else if (l == '5') {d(); d(); d(); d(); d();}
  else if (l == '6') {da(); d(); d(); d(); d();}
  else if (l == '7') {da(); da(); d(); d(); d();}
  else if (l == '8') {da(); da(); da(); d(); d();}
  else if (l == '9') {da(); da(); da(); da(); d();}
  else if (l == '0') {da(); da(); da(); da(); da();}
  else if (l == '.') {d(); da(); d(); da(); d(); da();}
  else if (l == ',') {da(); da(); d(); d(); da(); da();}
  else if (l == '?') {d(); d(); da(); da(); d(); d();}
  else if (l == '\'') {d(); da(); da(); da(); da(); d();}
  else if (l == '!') {da(); d(); da(); d(); da(); da();}
  else if (l == '/') {da(); d(); d(); da(); d();}
  else if (l == '(') {da(); d(); da(); da(); d();}
  else if (l == ')') {da(); d(); da(); da(); d(); da();}
  else if (l == '&') {d(); da(); d(); d(); d();}
  else if (l == ':') {da(); da(); da(); d(); d();d();}
  else if (l == ';') {da(); d(); da(); d(); da(); d();}
  else if (l == '=') {da(); d(); d(); d(); da();}
  else if (l == '+') {d(); da(); d(); da(); d();}
  else if (l == '-') {da(); d(); d(); d(); d(); da();}
  else if (l == '_') {d(); d(); da(); da(); d(); da();}
  else if (l == '"') {d(); da(); d(); d(); da(); d();}
  else if (l == '$') {d(); d(); d(); da(); d(); d(); da();}
  else if (l == '@') {d(); da(); da(); d(); da(); d();}

  // Plus the two below equals a delay of 7 tempos for a space
  if (l == ' ') {delay(5 * t);}

  // Delay of 3 tempos, 2, plus the delay after a character
  delay(2 * t);

}

// Set up the main loop which goes through the book
void loop() {

  // Decompression character buffer
  char out[1000];

  // For every line in t96.h
  for (int i=0; i < tao0_2_line_count; i++) {

    // Get the length of the current line
    int len = shox96_0_2_pgm_decompress(tao0_2, i, out, 0);

    // Set the final character of this line to 0 
    out[len] = 0;

    // For every character in this line 
    for (int c=0; c < len; c++) {

      // Write this letter to the screen
      Serial.write(out[c]);
        
      // Flash the morse equivalent for this character to the specified pin
      morse(out[c]);
      
    }

    // Write out a newline and a return character
    Serial.write("\n\r");
     
  }

}
